Ext.define('Base.data.actions.Sign', {
    
    async isNeedSign(data) {
        return await this.src.db.collection('signset').findOne({
            module: this.getName().replace(/\./g,'-') 
        },{active:1, priority:1});        
    }
            
    ,checkSignObject: function(data, sigSet) {
        let log = this.checkCanUserSign(sigSet) !== false;    
        data.list.each((d) => {
            this.checkSignObjectOne(d, log, sigSet)            
            return d;
        }, true)
    }
    
    ,checkCanUserSign: function(sigSet) {
        if(!sigSet || !sigSet.priority) return false; 
        for(var i = 0;i<sigSet.priority.length;i++) {
            if(sigSet.priority[i].user) {
                if(sigSet.priority[i].user+'' == this.user.id+'') {
                    return i;
                }
            } else
            if(sigSet.priority[i].group && sigSet.priority[i].group+'' == this.user.profile.groupid+'') {
                return i;
                break;
            }
        }
        return false;
    }
    
    ,checkSignObjectOne: function(d, canUserSign) {
        if(d.signobject) {
            d.signobject.shouldSign = false;
            if(canUserSign) {            
                d.signobject.signed = this.checkSignedObject(d.signobject.signs)
                d.signobject.shouldSign = true;//!d.signobject.signed;                    
            } else
            if(d.maker+'' == (this.user.id || this.user._id)+'') {
                d.signobject.shouldSign = true    
            }else
            if(
               this.fieldParentId &&  
               this.user.pid &&
               this.user.pid == d[this.fieldParentId]
            ) {
                d.signobject = {shouldSign: true} 
            } 
            if(d.signobject.signs && d.signobject.signs.length) {
                d.signobject.blocked = true;    
            } 
            
        } else {
            

            if(d.maker+'' == (this.user.id || this.user._id)+'') {                 
                d.signobject = {shouldSign: true}    
            } else
            if(
                this.fieldParentId &&  
                this.user.pid &&
                this.user.pid == d[this.fieldParentId]
             ) {
                 d.signobject = {shouldSign: true} 
             }
        }        
        
    }
    
    ,checkSignedObject: function(signs) {
        for(var i = 0;i<signs&&signs.length;i++) {
            if(signs+'' == this.user.id+'') return true;                
        }
        return false;
    }  

    ,async AutoSignDo(data) {        
        if(!this.user) {
            const d = await this.src.db.collection('admin_users').findOne({$or:[{superuser:1}, {superuser:true}]},{});
            if(d) {
                this.user = {id: d._id, profile: d}
            }            
        }     
        await this.$signRecord(data);
        return true;
    }
     
    ,async $signRecord(data) {
        var _id = this.src.db.fieldTypes[this.fields[0].type].StringToValue(data[this.idField]);
        
        
        let sigSet = await this.isNeedSign();
        let curUserSigIndex = this.checkCanUserSign(sigSet);
        if(!sigSet) {                        
            return {success: false, mess: 'Access denied 1'}   
        }
        let oo = {};
        oo[this.idField] = _id;
        
        let curRec = this.dbCollection.findOne(oo, {});
        
        this.checkSignObjectOne(curRec, true, sigSet)
                   
        if(curRec.signobject && curRec.signobject.shouldSign) {            
            curRec[me.idField] = _id;
        } else {
            return {success: false, mess: 'Access denied 2'}
        }

        if(curUserSigIndex === false) curUserSigIndex=0;
        else curUserSigIndex++;
        
        if(!curRec.signobject.signs) curRec.signobject.signs = []; 
        
        if(!this.checkSignedObject(curRec.signobject.signs)) {                   
            curRec.signobject.signs.push(this.user.id);                    
            if(!curRec.signobject.history)
                curRec.signobject.history = []
            curRec.signobject.history.push({
                date: new Date(),
                user: this.user.profile.name || this.user.profile.login,
                note: 'Signed'
            })
        }                    
                
        let toSaveData = {signobject: curRec.signobject}
        
        // если есть следующий подписант в списке,
        // отправим ему сообщение
        if(this.isNeedSendSigMessage && sigSet.priority[curUserSigIndex]) {
            await this.sendSigMessage(
                sigSet.priority[curUserSigIndex],
                curRec[this.idField],
                'sign',
                ''
            )
        } else {
            // если нет, опубликуем сообщение                    
            await this.sendMessageOnSignActivate(curRec);
            if(!!this.onSignActivate) {
                let x = await this.onSignActivate(curRec, function(x) {
                toSaveData.active = (x !== false);                
            } else {
                toSaveData.active = true;                        
            }
        }                    
            
        oo = {};
        oo[this.idField] = curRec[this.idField];               
        let d = await me.dbCollection.update(oo,{$set:toSaveData}, function(e,d) {
        if(!d)            
            return {success: false, mess: 'Access denied 3'}
        
        if(!!this.onSign) {
            toSaveData[this.idField] = curRec[this.idField];
            await this.onSign(toSaveData, curRec);
        }
        return {success: true}
    }
    
    ,async $unSignRecord (data, cb) {
        var sigSet
            ,curUserSigIndex
            ,_id = this.src.db.fieldTypes[this.fields[0].type].StringToValue(data[this.idField]);

        let oo = {};
        oo[this.idField] = _id;
        let curRec = await this.dbCollection.findOne(oo, {});
        if(!curRec)   
            return {success: false, mess: 'Not found'}
        
        if(!this.canMakerUnsign || curRec.maker+'' == this.user.id+'') {
            sigSet = await this.isNeedSign(curRec);
            curUserSigIndex = this.checkCanUserSign(sigSet);
            if(!sigSet || curUserSigIndex === false) {                      
                return {success: false, mess: 'Access denied'};       

        }
    
        if(!curRec.signobject){
            curRec.signobject={};
        }
        curRec.signobject.signs = []
        curRec.signobject.blocked = false;
        if(!curRec.signobject.history)
            curRec.signobject.history = []
        curRec.signobject.history.push({
            date: new Date(),
            user: this.user.profile.name || this.user.profile.login,
            note: data.note
        })
        let find = {};
        find[this.idField] = _id;
        var setObj = {signobject: curRec.signobject, active: false};
        
        await this.dbCollection.update(find, {$set: setObj});
    
        if(curRec.maker+'' != this.user.id+'') {            
            this.sendSigMessage({user:curRec.maker}, curRec[this.idField], 'unsign', data.note)    
        }
        if(!!this.onUnSign) 
            await this.onUnSign(curRec, data.note, find);
        
        return {success: true};
    
    }
    
    ,buildSigUrl: function(recId) {
        return '#'+Object.getPrototypeOf(this).$className.replace('.model.','.view.').replace(/Model$/, 'Form')+'~'+recId
    }
    
    ,async sendSigMessage (user, recId, type, note) {
        var msg,
            sbj,
            to,
            uri;

        let usrIds = await this.getSigUsersForMessage(user); 
        if(usrIds) {
            uri = this.buildSigUrl(recId)
            if(type == 'sign') {
                sbj = this.config.messages.signSubject
                msg = this.config.messages.signBody
                          .replace('{uri}', uri)
            } else
                if(type == 'unsign') {
                    sbj = this.config.messages.unsignSubject
                    msg = this.config.messages.unsignBody
                          .replace('{uri}', uri)
                          .replace('{note}', note)
                }
                
                Ext.create('Crm.modules.messages.model.MessagesModel', {
                    scope: me
                })
                .write({
                    subject: sbj,
                    body: msg,
                    to: usrIds,
                    touser: usrIds
                }, function() {
                    cb()
                },{add: true})      
            } else
                cb()
        }, recId)
    }
    
    ,getSigUsersForMessage: function(users, cb) {
        cb(users.user+'')
    }

    ,$getFileFromField: function(data, cb) {
        if(!data || !data.name || !data[this.idField]) {
            this.error(404)
            return;
        }
        var me = this,
            fld = {}
            _id = me.src.db.fieldTypes[me.fields[0].type].StringToValue(data[this.idField]);
        fld[data.name] = 1;
        var oo = {};
        oo[me.idField] = _id;
        me.dbCollection.findOne(oo, fld, function(e,d) {
            if(d && d[data.name] && d[data.name].data && d[data.name].name) {
                me.sendFile(d[data.name]);
            } else {
                me.error(404)
            }
        })
    }

    ,sendFile: function(data) {
        var headers = {
            'Content-Disposition': 'attachment; filename="' + encodeURIComponent(data.name) + '"',
            'Content-Length': data.data.buffer.length
        }
        this.response.writeHead(200, 'OK', headers);
        this.response.end(data.data.buffer);
    }
    

    ,getFilterByName: function(params, name, remove) {
        var f;
        if(params._filters) {
            for(var i = 0;i < params._filters.length; i++) {
                if(params._filters[i]._property == name) {
                    f = {operator: params._filters[i]._operator, value: params._filters[i]._value};
                    if(remove) {
                        params._filters.splice(i,1)
                    }
                    return f;
                }

            }
        }
        if(params.filters) {
            for(var i = 0;i < params.filters.length; i++) {
                if(params.filters[i].property == name) {
                    f = params.filters[i];
                    if(remove) {
                        params.filters.splice(i,1)
                    }
                    return f;
                }
            }
        }
        return null;
    }    


    ,sendMessageOnSignActivate: function(data, cb) {
        if(!this.config.messages || !this.config.messages.signSuccessSubject) {
            cb();
            return;
        }
        
        var view = this.viewForm || this.getName().replace('.model.','.view.').replace('Model','Form');
        
        var mess = {
            subject: this.config.messages.signSuccessSubject,
            touser: [data.maker], 
            body: Ext.create('Ext.XTemplate', this.config.messages.signSuccessBody).compile().apply({
                uri: view + '~' + data._id
            })
        }        
        Ext.create('Crm.modules.messages.model.MessagesModel', {scope: this})
        .write(mess, function() {
            cb(data)
        }, {add: true});        
    }
})