/**
 * @author Max Tushev
 * @class Database.drivers.Mongodb.fieldtype.number
 * @extend Database.fieldtype.Field
 * Integer number field. Use number field in the form for this data type.
 */
Ext.define('Database.drivers.Mongodb.fieldtype.number', {
    extend: 'Database.fieldtype.Field'
    
    ,getValueToSave: function(model, value, newRecord, oldRecord, name, callback) { 
        
        if(value) {
            value = (value+'').replace(/\s/g,'')
            value = parseInt(value);
        } else
            value = 0;
        callback(isNaN(value)? 0:value);
    }
    ,getFilterValue: function(model, filter, name, callback) {
        var f = {}
        var val = parseInt(filter.value)
        
        if(isNaN(val)) {
            callback(null)
            return;
        }
        
        if(filter.operator && ['lt','gt','lte','gte'].indexOf(filter.operator) != -1) {
            f[name] = {}
            f[name]['$' + filter.operator] = val
        } else
            f[name] = val
        
        callback(f)   
    }
})