/**
 * @author Max Tushev
 * @class Database.drivers.Oracle.fieldtype.string
 * @extend Database.fieldtype.Field
 * String field.
 */
Ext.define('Database.drivers.Postgresql.fieldtype.array', {
    extend: 'Database.drivers.Mongodb.fieldtype.array'

    
    ,getFilterValue: function(model, filter, name, callback) {        
         var f = {}
         f[name+'___'] = '{"_arr":['+(Ext.isString(filter.value)? '"' + filter.value+'"':filter.value)+']}'
         if(!!callback) callback(f);
         else  
             return f;
    }
    
    ,getDisplayValue: function(model, record, name, callback) {        
        callback(record[name] || null)//callback (record[name] && record[name].arr? record[name].arr: null);

    }
    
    //,getValueToSave: function(model, value, newRecord, oldRecord, name, cb) {      
    //    cb(value)//cb({arr:value})
   // }
    
    ,createField: function(field, collection, db, callback) {
        callback("ALTER TABLE " + collection + " ADD " + this.getDbFieldName(field) + " JSONB");
    }
    
    ,createIndex: function(field, collection) {
        return "CREATE INDEX " +collection+ "_"+field+" ON " +collection+ " ((("+field+" ->> '_arr')::varchar));"
    }
})