/**
 * @author Max Tushev
 * @class Database.drivers.Oracle.fieldtype.date
 * @extend Database.drivers.Mysql.fieldtype.date
 * Date field. Use date field in the form for this data type.
 */
Ext.define('Database.drivers.Postgresql.fieldtype.date', {
    extend: 'Database.drivers.Mysql.fieldtype.date'

    ,createField: function(field, collection, db, callback) {
        callback("ALTER TABLE " + collection + " ADD " + this.getDbFieldName(field) + " TIMESTAMP");
    }
    
    ,getValueToSave: function(model, value, newRecord, oldRecord, name, callback) { 
        callback(value? new Date(value).getTime():null)
    }
    
    ,getDisplayValue: function(model, record, name, callback) {
        if(record) callback(new Date(record[name]))
        else callback(null)
    }
    
    ,getFilterValue: function(mdl, filter, name, cb) {
        if(filter) {
            var 
                param = {},
                operator = filter.operator || filter._operator;
                
            param[filter.property] = {};

            if(operator){
              if(operator == 'eq')
                param[filter.property]={"$gte":Ext.Date.format(new Date(filter.value), 'd-M-Y'),"$lt": Ext.Date.format(new Date(new Date(filter.value).setDate(new Date(filter.value).getDate() + 1)), 'd-M-Y')}
              else if(operator == 'ne')
                  param[filter.property]={'$or':[{"$gte":Ext.Date.format(new Date(new Date(filter.value).setDate(new Date(filter.value).getDate() + 1)), 'd-M-Y')},{"$lt": Ext.Date.format(new Date(filter.value), 'd-M-Y')}]}
              else
                param[filter.property]['$' + operator] = Ext.Date.format(new Date(filter.value), 'd-M-Y');
            }

            else
                param[filter.property] = new Date(filter.value).getTime();//Ext.Date.format(new Date(filter.value), 'd-M-Y');
            cb(param)
        } else
            cb()
    }
})