/**
 * @author Max Tushev
 * @class Database.drivers.Mongodb.fieldtype.date
 * @extend Database.fieldtype.Field
 * Date field. Use date field in the form for this data type.
 */
Ext.define('Database.fieldtype.date', {
    extend: 'Database.fieldtype.Field'

    ,getExportValue: function(val) {
        if(val) val = Ext.Date.format(val, 'Y-m-d');
        return val;
    }
    
    ,getFilterValue: function(mdl, filter, name, cb) {
        if(filter) {
            var param = {}            
            param[filter.property] = {};
            if(Ext.isObject(filter.value)) {
                if(filter.value.from) {
                    param[filter.property].$gte = new Date(filter.value.from)
                }
                if(filter.value.to) {
                    param[filter.property].$lte = new Date(filter.value.to)
                }
            } else {           
                
                param[filter.property]['$' + filter.operator] = new Date(filter.value);
            }
            cb(param)
        } else
            cb()
    }

})